/**
 * 配置值读取器.
 *
 * @author yusangeng@outlook.com
 */
import { HasOnlyStringKey, KonphOptions, KonphGlobal } from "./types";
/**
 * 配置值读取器.
 *
 * @class Reader
 * @private
 */
export default class Reader<T extends HasOnlyStringKey<T>> {
    private globalConf_;
    private urlConf_;
    private options_;
    private cache_;
    private fitContext_;
    /**
     * 构造函数.
     *
     * @param {KonphGlobal} globalConf 全局配置变量.
     * @param {string} url url字符串.
     * @param {KonphOptions} options 配置项读取设置.
     *
     * @memberof Reader
     */
    constructor(globalConf: KonphGlobal<T>, url: string, options: KonphOptions<T>);
    /**
     * 读取配置项.
     *
     * @param {string} key 配置项名称(不区分大小写)，两边的空格会被trim掉.
     * @returns {any} 配置项的值.
     *
     * @memberof Reader
     * @instance
     */
    item<K extends keyof T>(key: K): T[K];
}
